/* reidai5-2.c --- 常微分方程式の初期値問題を Euler 法で解く */

#include <stdio.h>
#include <math.h>

int main(void)
{
  /* 開始時刻と終了時刻 */
  double a = 0.0, b = 1.0;
  /* 初期値 */
  double x0;
  /* 変数と関数の宣言 */
  double t,x,h,f(double,double),e;
  int N0,N1,N2,N,i;
  /* 自然対数の底 e (=2.7182818284..) */
  e = exp(1.0);
  /* 初期値の設定 */
  x0 = 1.0;
  /* どういう N について計算するか？ 
   * N0 から N1 まで、N2 刻みで増える N に */
  printf("FIRSTN,LASTN,STEPN=");
  scanf("%d%d%d", &N0,&N1,&N2);
  /* 計算の開始 */
  for (N = N0; N<= N1; N += N2) {
    h = (b-a)/N;
    /* 開始時刻と初期値のセット */
    t = a;
    x = x0;
    /* Euler 法による計算 */
    for (i = 0; i < N; i++) {
      x += h * f(t,x);
      t += h;
    }
    printf("%d %e\n", N, fabs(e-x));
  }
  return 0;
}

/* 微分方程式 x'=f(t,x) の右辺の関数 f の定義 */
double f(double t, double x)
{
  return x;
}
